import javax.microedition.lcdui.Alert;
import javax.microedition.lcdui.AlertType;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;



/**
 * @author Gregor Broll, Alex De Luca
 * 
 * This midlet sends arbitrary string inputs to a server and keeps a history of its last 5 responses
 */
public class PMP3Midlet extends MIDlet
{
	private Display display;
	private RecordManager recordManager;					//used to handle all operations on the record management system
	
	
	/**
	 * Constructor; instantiates the display and the recordmanager
	 */
	public PMP3Midlet()
	{
		super();		
		display = Display.getDisplay(this);
		recordManager = new RecordManager();
	}	

	
	/**  
	 * Just puts the first interface on the screen
	 */
	protected void startApp() throws MIDletStateChangeException
	{
		showDisplayable(new InputForm(this, recordManager));	
	}
	
	
	/**
	 * Generic method for showing displayables
	 * 
	 * @param displayable
	 */
	public void showDisplayable(Displayable displayable)
	{
		display.setCurrent(displayable);
	}
	
	
	/**
	 * Generic method for showing alerts
	 * 
	 * @param title
	 * @param text
	 */
	public void showAlert(String title, String text, Displayable next)
	{
		Alert alert = new Alert(title, text, null, AlertType.INFO);
		alert.setTimeout(Alert.FOREVER);
		display.setCurrent(alert, next);
	}

	
	/**
	 * 
	 */
	protected void pauseApp()
	{
	}

	
	/**
	 * Closes the recordstore before exiting the midlet.
	 */
	protected void destroyApp(boolean arg0) throws MIDletStateChangeException
	{
		recordManager.closeRecordStore();
		notifyDestroyed();
	}
}
